<?php
	/**
		* @package		EasyBlog
		* @copyright	Copyright (C) 2010 Stack Ideas Private Limited. All rights reserved.
		* @license		GNU/GPL, see LICENSE.php
		*
		* EasyBlog is free software. This version may have been modified pursuant
		* to the GNU General Public License, and as distributed it includes or
		* is derivative of works licensed under the GNU General Public License or
		* other free or open source software licenses.
		* See COPYRIGHT.php for copyright notices and details.
	*/
	defined('_JEXEC') or die('Restricted access');
?>
<div id="ezblog-latestcomment" class="ezb-mod latest-comments<?php echo $params->get( 'moduleclass_sfx' ) ?>">
	<?php if( $comments ){ ?>
		<?php foreach( $comments as $comment ){
			
			$tmpObj = new stdClass();
			$tmpObj->category_id    = $comment->category_id;
			$tmpObj->created_by     = $comment->author_id;
			$tmpObj->id    					= $comment->post_id;
			
			$itemId = modEasyBlogLatestCommentHelper::_getMenuItemId($tmpObj, $params);
			
		?>
		<div class="mod-item">
			<div class="mod-comment-head">
				<?php if( $params->get( 'showavatar' ) ){ ?>
				<div class="mod-avatar">
					<img src="<?php echo $comment->author->getAvatar();?>" width="60" class="avatar" />
				</div>
				<?php } ?>
				<div class="top-comment">
				<?php if( $params->get( 'showauthor') ) {
					$author = '';
					if( $comment->created_by == 0)
					{
						$author = $comment->name;
					}
					else
					{
						$author	= '<a href="' . EasyBlogRouter::_( 'index.php?option=com_easyblog&view=blogger&layout=listings&id=' . $comment->author->id . $itemId ) . '"><b>' . $comment->author->getName() . '</b></a>';
					}
				?>
				<div class="post-author">
					<span class="comment-author"><?php echo $author;?></span>
								</div>
				<?php } ?>
				<span class="post-date"><?php echo $comment->dateString; ?></span>

				</div>
				<div class="mod-post-title">
					<a href="<?php echo EasyBlogRouter::_( 'index.php?option=com_easyblog&view=entry&id=' . $comment->post_id . $itemId );?>#comment-<?php echo $comment->id;?>">
						<?php if( $params->get( 'showtitle' ) ){ ?>
						<?php echo (JString::strlen($comment->blog_title) > $maxTitleLen) ? JString::substr($comment->blog_title, 0, $maxTitleLen) . '...' : $comment->blog_title; ?>
						<?php } else { ?>
						<span>#</span>
					<?php } ?>
					</a>
				</div>
				<div class="mod-comment-content">
					<?php
						$text	= EasyBlogHelper::getHelper( 'Comment' )->parseBBCode( $comment->comment );
						echo JString::strlen( strip_tags( $text ) ) > $maxCharacter ? JString::substr( strip_tags( $text ) , 0 , $maxCharacter ) . '...' : strip_tags( $text );
					?>
				</div>
			</div>	
			
		</div>
		<?php } ?>
	<?php } else { ?>
		<div><?php echo JText::_('MOD_EASYBLOGLATESTCOMMENT_NO_POST'); ?></div>
	<?php } ?>
</div>
								